/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: ipupdater.h,v 0.1 2007/09/29 15:50:42 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#ifndef _IPUPDATERH_
#define _IPUPDATERH_

#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE
#endif
#ifndef _CRT_NONSTDC_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE
#endif

#define IPU_GET 0
#define IPU_POST 1
#define IPU_SUCCESS 0
#define IPU_ERROR 1
#define UPDATE_URL "http://vfose.ru/updater.php"

#include <stdlib.h>
#include <algorithm>
#include <time.h>
#include "socklib.h"
#include "configlib.h"

#ifndef WIN32
#include <sys/time.h>
#endif

typedef struct {std::string time; char ip[16]; std::string status; int intstatus;} STATUS;
typedef std::map<std::string, STATUS> STATUSARY;

class ipupdater
{
	public:
		ipupdater();
		~ipupdater();

		void check();
		char *GetExtAddr(char *buff);
		int UpdateDomain(char *login, char *hash, char *url = UPDATE_URL);
		void UpdateAllDomains();
		char *GetStatus();

		void SetErrorCallback(pSLErrorCallback ec);
		char *HTTPGetResponse(char *url);
		char *HTTPPostQuery(char *url, CFGARRAY params);

	private:
		socklib *net;
		SL_SET netSet;
		time_t lastUpdate;
		char lastIp[16];
		char *httpBuf;
		char *strStatus;
		pSLErrorCallback cbError;
		STATUSARY status;

		char * ReceiveHTTPResponse(char *url, u_short method, CFGARRAY *data);
		void RealError(int errcode, char *file, int line);
};

void cbError(int errcode, char* errstr, char *file, int line);

#endif
