/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: socklib.h,v 0.1 2007/09/29 15:51:15 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#ifndef _SOCKLIBH_
#define _SOCKLIBH_

#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE
#endif
#ifndef _CRT_NONSTDC_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE
#endif

#include <stdio.h>
#include <memory.h>

#ifdef WIN32
#include <winsock2.h>

typedef int socklen_t;
#else
#define __STDLIB
#define __SOCK

#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "win2linux.h"
#endif

#define SL_TCP IPPROTO_TCP
#define SL_UDP IPPROTO_UDP

#define SLE_NOERROR				0
#define SLE_WSASTARTUP			1
#define SLE_WSACLEANUP			2
#define SLE_INVALID_SOCKET		3
#define SLE_BIND				4
#define SLE_CONNECT				5
#define SLE_SEND				6
#define SLE_RECV				7
#define SLE_LISTEN				8
#define SLE_ACCEPT				9

#define Error(errcode) RealError(errcode, __FILE__, __LINE__)

typedef struct
{
	short PROTO;

	char ServerIP[256];
	char ClientIp[256];
	u_short ServerPort;
	u_short BindPort;

	int so_broadcast;
	int so_keepalive;
	int so_recvtimeo;
	
} SL_SET;

typedef void (*pSLErrorCallback)(int errcode, char *errstr, char *file, int line);
typedef void (*pSLRecvCallback)(char *packet, size_t packetLn, char *from);
typedef void (*pSLAcceptCallback)(char *from);

class socklib
{
	public:
		socklib(bool StartWSA = false);
		~socklib();

		void SetUp(SL_SET sl_set);
		void SetCallbacks(pSLErrorCallback ec, pSLRecvCallback rc = NULL, pSLAcceptCallback ac = NULL);

		void Start();
		void Stop();
		void Send(char *packet, size_t len);
		void SendTo(char *packet, size_t len, char *addr);
		void Recv();
		char *RecvEx(char *buff, size_t* len, char *fromBuff);
		void Accept(char *fromBuff);

	private:
#ifdef WIN32
		WSADATA WsaData;
		bool stopWSA;
#endif
		SOCKET sock;
		SOCKET cSock;
		SL_SET set;
		pSLErrorCallback cbError;
		pSLRecvCallback cbRecv;
		pSLAcceptCallback cbAccept;

		void RealError(int errcode, char *file, int line);
};

#endif
