/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: terminal.h,v 0.1 2007/09/29 15:51:25 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#ifndef _TERMINALH_
#define _TERMINALH_

#ifdef WIN32
#define _WIN32_WINNT 0x0501
#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE
#endif
#ifndef _CRT_NONSTDC_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE
#endif
#endif

#define WELCOME \
"VorteX vFOSe.ru IPUpdater v0.1\r\n\
License: GNU General Public License version 2\r\n\
Copyright (C) 2007 Yuri Konotopov a.k.a. nE0sIghT\r\n\r\n"


#include <stdio.h>
#include <stdlib.h>
#include "socklib.h"
#include "configlib.h"

#ifndef WIN32
#include <pthread.h>

#define __stdin stdin
#define __stdout stdout

typedef pthread_t HANDLE;
typedef void * THREAD_START_ROUTINE;
#else
#include <windows.h>
#include <fcntl.h>
#include <io.h>
typedef unsigned long THREAD_START_ROUTINE;

#endif

#define TERM_CONSOLE	0
#define TERM_TELNET		1

#define ECHO				  1
#define SGA					  3
#define STATUS				  5
#define BEL					  7
#define BS					  8
#define HT					  9
#define LF					 10
#define VT					 11
#define FF					 12
#define CR					 13
#define SE                  240		//End of subnegotiation parameters.
#define NOP                 241		//No operation.
#define DATA_MARK           242		//The data stream portion of a Synch. This should always be accompanied by a TCP Urgent notification.
#define BRK		            243		//NVT character BRK.
#define IP					244		//The function IP.
#define AO			        245		//The function AO.
#define AYT					246		//The function AYT.
#define EC					247		//The function EC.
#define EL					248		//The function EL.
#define GA					249		//The GA signal.
#define SB                  250		//Indicates that what follows is subnegotiation of the indicated option.
#define WILL				251		//Indicates the desire to begin performing, or confirmation that you are now performing, the indicated option.
#define WONT				252		//Indicates the refusal to perform, or continue performing, the indicated option.
#define DO					253		//Indicates the request that the other party perform, or confirmation that you are expecting the other party to perform, the indicated option.
#define DONT				254		//Indicates the demand that the other party stop performing, or confirmation that you are no longer expecting the other party to perform, the indicated option.
#define IAC                 255		//Data Byte 255.

typedef void (*termReadCallback)(char *line);

THREAD_START_ROUTINE TerminalThread(void*);
void StartTerminal();
void StopTerminal();
void TermSend(char *msg);
void TermRead();
char *TermReadEx(char *buff);
void ExecCmd(char *cmd);
void SetReadCallback(termReadCallback cr);

#endif
