/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: configlib.cpp,v 0.1 2007/09/29 15:48:56 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#define CONFIG_PREFIX "#VorteX vFOSe.ru IPUpdater autogenerated config file\n\nversion = 0.1\n"

#include "configlib.h"

configlib::configlib(char *filename)
{
	FILE *hFile;

	if(hFile = fopen(filename, "rt"))
	{
		char line[MAX_CFG_LEN*2],
		param[MAX_CFG_LEN],
		value[MAX_CFG_LEN],
		*ptr = line;

		while(fgets(line, sizeof(line), hFile))
		{
			ptr = line;

			while(*ptr && (*ptr == 0x20 || *ptr == 9))
				ptr++;

			if(!*ptr || *ptr == '#' || *ptr == ';' || *ptr == '\n' || strlen(ptr) < 3)
				continue;

			while(*ptr && *ptr != '='){ptr++;}
			if(*ptr != '=')
				continue;

			ptr--;
			while(*ptr && (*ptr == 0x20 || *ptr == 9)){ptr--;}
			ptr++;

			strncpy(param, line, ptr - line);
			param[ptr-line] = 0;

			while(*ptr && *ptr != '='){ptr++;}
			ptr++;
			while(*ptr && (*ptr == 0x20 || *ptr == 9)){ptr++;}

			char *vPtr = ptr;
			while(*ptr && *ptr != ';' && *ptr != '#' && *ptr != '\n'){ptr++;}
			ptr--;
			while(*ptr && (*ptr == 0x20 || *ptr == 9)){ptr--;}
			ptr++;

			strncpy(value, vPtr, ptr - vPtr);
			value[ptr - vPtr] = 0;

			cfg[param] = value;
		}

		fclose(hFile);
	}
}

bool configlib::IsSet(char *key)
{
	if(cfg.find(key) != cfg.end())
	{
		if(cfg[key].length())
			return true;
	}

	return false;
}

char *configlib::GetCfgVar(char *key)
{
	if(cfg.find(key) != cfg.end())
		return (char*)cfg[key].c_str();
	else
		return NULL;
}

int configlib::GetIntCfgVar(char *key)
{
	if(cfg.find(key) != cfg.end())
		return atoi(cfg[key].c_str());
	else
		return 0;
}

char *configlib::SetCfgVar(char *key, char *value)
{
	cfg[key] = value;
	return 0;
}
char *configlib::SetIntVar(char *key, int value)
{
	cfg[key] = value;
	return 0;
}

void configlib::DeleteVar(char *key)
{
	cfg[key].clear();
}

void configlib::SaveConfig(CFGARRAY *ary, char *filename)
{
	FILE *hFile;

	if(!ary)
		ary = &cfg;

	if(hFile = fopen(filename, "wt"))
	{
		CFGARRAY::iterator iter;
		char *buff = 0;

		fwrite(CONFIG_PREFIX, strlen(CONFIG_PREFIX), 1, hFile);
		for(iter = ary->begin(); iter != ary->end(); iter++)
		{
			buff = (char*)realloc((void*)buff, iter->first.length()+iter->second.length()+6);
			sprintf(buff, "%s = %s\n", iter->first.c_str(), iter->second.c_str());

			fwrite(buff, strlen(buff), 1, hFile);
		}
		if(buff)
			free(buff);

		fclose(hFile);
	}
}
