/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: ipupdater.cpp,v 0.1 2007/09/29 15:49:11 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#include "ipupdater.h"

extern configlib cfg;

ipupdater::ipupdater()
{
	net = new socklib(false);
	httpBuf = strStatus = 0;
	lastUpdate = 0;
	ZeroMemory(lastIp, sizeof(lastIp));

	netSet.PROTO = SL_TCP;
	strcpy(netSet.ServerIP, "88.147.147.202"); // vfose.ru TODO
	netSet.ServerPort = 80;
	netSet.so_recvtimeo = 2000; // cfg

	net->SetUp(netSet);
	ZeroMemory(&netSet, sizeof(SL_SET));
}

ipupdater::~ipupdater()
{
	delete net;
	if(httpBuf)
		free(httpBuf);
}

void ipupdater::check()
{
	if((time(NULL) - lastUpdate) > cfg.GetIntCfgVar("UpdateInterval"))
	{
		time(&lastUpdate);
		UpdateAllDomains();
	}
}

char *ipupdater::GetExtAddr(char *buff)
{
	char *ip = HTTPGetResponse(UPDATE_URL);

	if(ip && strlen(ip) < 16)
		sprintf(buff, ip);

	return buff;
}

char *ipupdater::HTTPGetResponse(char *url)
{
	return ReceiveHTTPResponse(url, IPU_GET, NULL);
}

char *ipupdater::HTTPPostQuery(char *url, CFGARRAY params)
{
	return ReceiveHTTPResponse(url, IPU_POST, &params);
}

char *ipupdater::ReceiveHTTPResponse(char *url, u_short method, CFGARRAY *data)
{
	char fGETRequest[] = "GET %s HTTP/1.0\r\nHost: %s\r\nAccept: */*\r\nUser-Agent: Vortex vFOSe.ru IpUpdater\r\nCache-Control: no-cache\r\nConnection: close\r\n\r\n";
	char fPOSTRequest[] = "POST %s HTTP/1.0\r\nHost: %s\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %i\r\nAccept: */*\r\nUser-Agent: Vortex vFOSe.ru IpUpdater\r\nCache-Control: no-cache\r\nConnection: close\r\n\r\n%s";
	char buff[8192], server[256] = {0}, file[256] = {0};

	sprintf(buff, url);
	if(httpBuf)
	{
		free(httpBuf);
		httpBuf = 0;
	}

	if(!strnicmp(url, "http://", 7))
	{
		char *pBuff = buff;
		size_t len = sizeof(buff);

		pBuff += 7;

		while(*pBuff && *pBuff != '/')
			pBuff++;
		strncpy(server, buff+7, pBuff - (buff+7));
		strcpy(file, pBuff);

		/* */
		if(method == IPU_GET)
		{
			sprintf(buff, fGETRequest, file, server);
		}
		else if(method == IPU_POST && data)
		{
			CFGARRAY::iterator iter;
			size_t len = 1;

			for(iter = data->begin(); iter != data->end(); iter++)
				len += strlen(iter->first.c_str()) + strlen(iter->second.c_str()) + 2;

			if(len == 1)
				return httpBuf;
			else
			{
				char *post = (char *)calloc(len, 1);
				char *pPost = post;

				for(iter = data->begin(); iter != data->end(); iter++)
				{
					pPost = post + strlen(post);
					sprintf(pPost, "%s%s=%s", (strlen(post) ? "&" : ""), iter->first.c_str(), iter->second.c_str());
				}

				sprintf(buff, fPOSTRequest, file, server, strlen(post), post);
				free(post);
			}
		}
		else
			return httpBuf;

		net->Start();
		net->Send(buff, strlen(buff));
		net->RecvEx(buff, &len, NULL);
		net->Stop();

		if(len)
		{
			if(!strnicmp(buff, "HTTP/1.0", 8)) //We got HTTP 1.0 response
			{
				pBuff = buff+9;
				if(!strncmp(pBuff, "200", 3)) // Got data
				{
					while(strnicmp(pBuff, "Content-Length: ", 16) && *pBuff)
						pBuff++;
					if(*pBuff)
					{						
						pBuff += 15;

						char *tpBuff = pBuff;
						while(strncmp(pBuff, "\r\n", 2) && *pBuff)
							pBuff++;
						if(*pBuff)
						{
							char *tcLen = (char*)malloc(pBuff - tpBuff);
							strncpy(tcLen, tpBuff, pBuff-tpBuff);
							size_t cLen = atoi(tcLen);
							free(tcLen);

							while(strncmp(pBuff, "\r\n\r\n", 4) && *pBuff)
								pBuff++;

							if(*pBuff)
							{
								pBuff += 4;

								if(strlen(pBuff) == cLen)
								{
									httpBuf = (char *)calloc(cLen+1, 1);
									strncpy(httpBuf, pBuff, cLen);
								}
							}
						}
					}

				}
				else
				{
					/*char err[4] = {0};
					strncpy(err, pBuff, 3);*/

					Error(0); //TODO
				}
			}
		}
	}

	return httpBuf;
}

int ipupdater::UpdateDomain(char *login, char *hash, char *url)
{
	if(strlen(login) && strlen(hash))
	{
		CFGARRAY post;
		char date[512];

		post["name"] = login;
		post["pass"] = hash;
		post["action"] = "update";

		char *response = HTTPPostQuery(UPDATE_URL, post);

		tm *LocalTime;
		time_t timestamp;

		time(&timestamp);
		LocalTime = localtime(&timestamp);
		strftime(date, sizeof(date), "%d.%m.%y %H:%M:%S", LocalTime);

		status[login].time = date;

		if(response)
		{
			char errcode[32] = {0};
			char *pResp = response;

			while(*pResp && *pResp != '\n')
				pResp++;
			if(*pResp)
			{
				char ip[16] = {0};
				char *pIp = pResp+1; //\n

				strncpy(errcode, response, pResp - response);
				pResp++;

				while(*pResp && *pResp != '\n')
					pResp++;

				// No check for \0... No so correct now, but think right if zk will fix updater.php...
				if(pResp - pIp < 16)
				{
					strncpy(ip, pIp, pResp - pIp);
					sprintf(status[login].ip, ip);

					if(!strncmp(response, "UPDATE OK", 9))
					{
						status[login].intstatus = IPU_SUCCESS;
						status[login].status = "Successfull update";
					}
					else if(!strncmp(response, "ERROR SAME IP", 13))
					{
						status[login].intstatus = IPU_SUCCESS;
						status[login].status = "Success, IP not changed";
					}
					else if(!strncmp(response, "ERROR DOMAIN PASSWORD", 21))
					{
						status[login].intstatus = IPU_ERROR;
						status[login].status = "Error. Wrong domain and/or password";
					}
					else
					{
						status[login].intstatus = IPU_ERROR;
						status[login].status = "Error. Unknown return code received";
					}
				}
				else
				{
					status[login].intstatus = IPU_ERROR;
					status[login].status = "Error. Bad HTTP server response [IP]";
				}
			}
			else
			{
					status[login].intstatus = IPU_ERROR;
					status[login].status = "Error. Bad HTTP server response";
			}
		}
		else
		{
			status[login].intstatus = IPU_ERROR;
			status[login].status = "Error. No HTTP server response";
		}

	}
	return 0;
}

void ipupdater::UpdateAllDomains()
{
	int i = 0;
	char dBuff[12] = "Domain"; //100000 total posible domains -)
	char passBuff[9] = "Hash";
	char *dId = dBuff + strlen(dBuff);
	char *passId = passBuff + strlen(passBuff);
	char ip[16] = {0};

	if(strlen(GetExtAddr(ip)))
	{
		strcpy(lastIp, ip);
		do
		{
			sprintf(dId, "%i", i);
			sprintf(passId, "%i", i++);

			if(cfg.IsSet(dBuff) && cfg.IsSet(passBuff))
			{
				if(status.find(dBuff) == status.end())
					UpdateDomain(cfg.GetCfgVar(dBuff), cfg.GetCfgVar(passBuff));
				else if(strcmp(status[dBuff].ip, ip))
					UpdateDomain(cfg.GetCfgVar(dBuff), cfg.GetCfgVar(passBuff));
			}
		}
		while(cfg.GetCfgVar(dBuff));
	}
}

void ipupdater::SetErrorCallback(pSLErrorCallback ec)
{
	net->SetCallbacks(ec, NULL);
}

void ipupdater::RealError(int errcode, char *file, int line)
{
	if(cbError)
	{
		char StrErr[2048];
		char buff[1024] = {0};

#ifdef WIN32
		FormatMessage(
			FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			GetLastError(),
			LANG_SYSTEM_DEFAULT,
			buff,
			sizeof(buff),
			NULL
		);
#else
		sprintf(buff, "%s", strerror(errcode));
#endif

		sprintf(StrErr, "%s", buff);
		cbError(errcode, StrErr, file, line);
	}
}

char *ipupdater::GetStatus()
{
	STATUSARY::iterator iter;
	char gFormat[] = "Last check: %s\r\nDetected IP: %s\r\n-------------------------\r\n\r\n";
	char dFormat[] = "Domain: %s.vfose.ru\r\nLast update: %s\r\nIP: %s\r\nStatus: %s\r\n\r\n";
	char *pstStatus, date[128];
	size_t len = sizeof(gFormat);
	tm *LocalTime;

	if(strStatus)
		free(strStatus);

	for(iter = status.begin(); iter != status.end(); iter++)
		len += iter->first.length() + strlen(iter->second.ip) + iter->second.status.length() + iter->second.time.length() + strlen(dFormat);

	LocalTime = localtime(&lastUpdate);
	strftime(date, sizeof(date), "%d.%m.%y %H:%M:%S", LocalTime);

	strStatus = (char*)calloc(len+strlen(gFormat)+strlen(date), 1);
	sprintf(strStatus, gFormat, date, lastIp);

	for(iter = status.begin(); iter != status.end(); iter++)
	{
		pstStatus = strStatus + strlen(strStatus);
		sprintf(pstStatus, dFormat, iter->first.c_str(), iter->second.time.c_str(), iter->second.ip, iter->second.status.c_str());
	}

	return strStatus;
}

