/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: terminal.cpp,v 0.1 2007/09/29 15:50:2 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#include "terminal.h"

socklib term(false);
bool stopTerminal = false, TerminalStarted = false;
bool InTermCmd = false;
termReadCallback cbRead = 0;
int TermMode = TERM_CONSOLE;
#ifdef WIN32
FILE * __stdout = 0, *__stdin = 0;
#endif

extern bool stopThread;
extern configlib cfg;

void tcbError(int errcode, char *errstr, char *file, int line);
void tcbReceive(u_char *chr, size_t len, char *from);
void tcbAccept(char *from);
void TermOpt(u_char act, u_char cmd);

char cmdBuff[128] = {0};

THREAD_START_ROUTINE TerminalThread(void* mode)
{
	TermMode = (int)mode;
	StartTerminal();
	while(!stopThread)
	{
		TermRead();
		Sleep(100);
	}
	StopTerminal();

	return 0;
}

void StartTerminal()
{
	stopTerminal = false;

	if(TermMode == TERM_TELNET)
	{
		char from[16];
		SL_SET set = {0};

		set.BindPort = cfg.IsSet("AdminPort") ? cfg.GetIntCfgVar("AdminPort") : 10739;
		strcpy(set.ServerIP, cfg.IsSet("BindIP") ? cfg.GetCfgVar("BindIP") : "0.0.0.0");
		set.PROTO = SL_TCP;
		set.so_recvtimeo = 2000;

		term.SetCallbacks(tcbError, (pSLRecvCallback)tcbReceive, tcbAccept);
		term.SetUp(set);
		term.Start();

		while(!TerminalStarted)
		{
			term.Accept(from);
			Sleep(100);
		}
	}
	else //if(TermMode == TERM_CONSOLE)
	{
#ifdef WIN32
		AllocConsole();
		__stdout = _fdopen(_open_osfhandle((intptr_t)GetStdHandle(STD_OUTPUT_HANDLE), _O_WRONLY), "w");
		__stdin = _fdopen(_open_osfhandle((intptr_t)GetStdHandle(STD_INPUT_HANDLE), _O_RDONLY), "r");
		setvbuf(__stdout, NULL, _IONBF, NULL);
		setvbuf(__stdin, NULL, _IONBF, NULL);
#endif	

	}
}

void StopTerminal()
{
	stopTerminal = true;

	if(TermMode == TERM_TELNET)
	{
		term.Stop();
	}
	else
	{
#ifdef WIN32
		fclose(__stdin);
		fclose(__stdout);
#endif
	}
}

void TermRead()
{
	if(TermMode == TERM_TELNET)
		term.Recv();
	else
	{
		if(strlen(fgets(cmdBuff, sizeof(cmdBuff)-1, __stdin)))
		{
			if(cbRead)
				cbRead(cmdBuff);
			ZeroMemory(cmdBuff, sizeof(cmdBuff));
		}
	}
}

char *TermReadEx(char *buff)
{
	if(buff)
		strcpy(buff, "");

	if(TermMode == TERM_CONSOLE)
	{
		if(strlen(fgets(cmdBuff, sizeof(cmdBuff)-1, __stdin)))
		{
			if(buff)
			{
				for(size_t i = 0; i < strlen(cmdBuff); i++)
					if(cmdBuff[i] == '\r' || cmdBuff[i] == '\n')
						cmdBuff[i] = 0;
				return(strcpy(buff, cmdBuff));
			}
		}
	}
	else if(TermMode == TERM_TELNET) // pizda -)
	{
		char tBuff[256];
		size_t len = sizeof(tBuff);
		ZeroMemory(cmdBuff, sizeof(cmdBuff));

		while(term.RecvEx(tBuff, &len, NULL))
		{
#ifndef WIN32
			printf("[ DEBUG ]: %s\n", tBuff);
#endif
			if(strlen(tBuff) > 1)
			{
				if(!strncmp(tBuff, "\r\n", 2))
				{
					term.Send(tBuff, len);
					strcpy(buff, cmdBuff);
					ZeroMemory(cmdBuff, sizeof(cmdBuff));

					return buff;
				}
			}
			else
			{
				switch(tBuff[0])
				{
					case '\x08': // BackSpace
						cmdBuff[strlen(cmdBuff)-1] = 0;
						term.Send("\x08", 1);
						break;

					default:
						if(strlen(cmdBuff) == sizeof(cmdBuff) - 1)
						{
							TermSend("Error: Too long command\r\nType help for getting available commands\r\n\r\n");
							ZeroMemory(cmdBuff, sizeof(cmdBuff));
						}
						else
						{
							sprintf(cmdBuff+strlen(cmdBuff), "%c", tBuff[0]);
							term.Send(tBuff, 1);
						}
						break;
				}
			}
			len = sizeof(tBuff);
		}
	}

	return buff;
}

void tcbAccept(char *from)
{
	if(cfg.IsSet("AdminIP"))
	{
		if(!strcmp(cfg.GetCfgVar("AdminIP"), from))
		{
			TermOpt(DONT, ECHO);
			TermSend(WELCOME);
			while(!stopTerminal)
			{
				term.Recv();
				Sleep(100);
			}
			return;
		}
	}
	StopTerminal();
	StartTerminal();
}

void tcbReceive(u_char *chr, size_t len, char *from)
{
	if(len > 1)
	{
		if(!strncmp((char*)chr, "\r", 1))
		{
			term.Send((char*)chr, len);
			if(cbRead)
				cbRead(cmdBuff);
			ZeroMemory(cmdBuff, sizeof(cmdBuff));
		}
	}
	else
	{
		switch(*chr)
		{
			case '\x08': // BackSpace
				cmdBuff[strlen(cmdBuff)-1] = 0;
				term.Send("\x08", 1);
				break;

			default:
				if(strlen(cmdBuff) == sizeof(cmdBuff) - 1)
				{
					TermSend("Error: Too long command\r\nType help for getting available commands\r\n\r\n");
					ZeroMemory(cmdBuff, sizeof(cmdBuff));
				}
				else
				{
					sprintf(cmdBuff+strlen(cmdBuff), "%c", *chr);
					term.Send((char*)chr, 1);
				}
				break;
		}
	}
}

void tcbError(int errcode, char *errstr, char *file, int line)
{
	StopTerminal();
	StartTerminal();

#ifndef WIN32
	printf("%s:% - i%i %s\n", file, line, errcode, errstr);
#endif
	//TODO Error handling
}

void TermSend(char *msg)
{
	if(TermMode == TERM_CONSOLE)
		fprintf(__stdout, msg);
	else if(TermMode == TERM_TELNET)
		term.Send(msg, strlen(msg));
}

void TermOpt(u_char act, u_char cmd)
{
	u_char buff[5] = {IAC, act, cmd};
	term.Send((char*)buff, sizeof(buff));
}

void SetReadCallback(termReadCallback cr)
{
	cbRead = cr;
}
