/**
*
* @package VorteX vFOSe.ru IpUpdater
* @version $Id: vipr.cpp,v 0.1 2007/09/29 15:50:16 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license GNU General Public Lecense v2
*
*/


#define CONFIG_FILE "vipr.cfg"
#include "vipr.h"

bool ExitApp = false, stopThread = false, in_setup = false;
HANDLE hThread = 0;
configlib cfg(CONFIG_FILE);
ipupdater ipu;
pOutputFunc Output;
void cbAdmin(char *cmd);

void StartTerminalThread(void *param);
void StopTerminalThread();
void SetUp();
char *MD5Encode(char *string, OUT char *hash);

#ifdef WIN32
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
#else
int main(int argc, char* argv[])
#endif
{
#ifdef WIN32

	if((GetVersion()&0x80000000) == 1) //Win9x ?
	{
		MessageBox(NULL, "    ", "", MB_ICONERROR | MB_OK);
		exit(1);
	}
#endif

	if(!cfg.IsSet("RunType"))
		SetUp();
	else
	{
#ifdef WIN32
		WSAData WsaData;
		WSAStartup(MAKEWORD(2, 0), &WsaData);
#endif
#ifdef WIN32
		if(!stricmp(cfg.GetCfgVar("RunType"), "console"))
#endif
			StartTerminalThread((void*)TERM_CONSOLE);
#ifdef WIN32
		else
			StartTerminalThread((void*)TERM_TELNET);
#endif

		while(!ExitApp)
		{
			while(in_setup)
				Sleep(1000);

			ipu.check();
			Sleep(1000);
		}
		StopTerminalThread();
#ifdef WIN32
	WSACleanup();
#endif
	}


	return 0;
}

void SetUp()
{
	int stage = 0;
	int i = 0;
	char buff[256];
	CFGARRAY arr;
	StartTerminal();
	TermSend(WELCOME);

	in_setup = true;
	while(stage < 6)
	{
		switch(stage)
		{
			case 0:
			{
				char domain[128] = {0};
				char pass[128] = {0};
				char dBuff[12] = "Domain"; //100000 total posible domains -)
				char passBuff[9] = "Hash";
				char *dId = dBuff + strlen(dBuff);
				char *passId = passBuff + strlen(passBuff);

				TermSend("Enter a subdomain name in domain vfose.ru:\n");
				if(strlen(TermReadEx(domain)))
				{
					sprintf(buff, "\nEnter a password for domain %s.vfose.ru:\n", domain);
					TermSend(buff);
					if(strlen(TermReadEx(pass)))
					{
						char hash[33] = {0};
						sprintf(dBuff+strlen(dBuff), "%i", i);
						sprintf(passBuff+strlen(passBuff), "%i", i++);
						arr[dBuff] = domain;
						arr[passBuff] = MD5Encode(pass, hash);

						TermSend("\nAdd another subdomain? [yn]\n");
						if(stricmp(TermReadEx(buff), "y"))
							stage++;
					}
				}
			}
				
				break;
			case 1:
			{
				TermSend("\nEnter time interval between IP checks in secs:\n");
				if(strlen(TermReadEx(buff)))
				{
					arr["UpdateInterval"] = buff;
					stage++;
				}
			}
			case 2:
			{
				TermSend("\nEnter program run type: [console|telnet]\n");
				TermReadEx(buff);
				if(!stricmp(buff, "telnet") || !stricmp(buff, "console"))
				{
					arr["RunType"] = buff;
					stage++;
				}
				else
					TermSend("Wrong run type\n");

			}
				break;
			case 3:
			{
				TermSend("\nEnter a port number for telnet connection(ignored if console run type was choosed):\n");
				TermReadEx(buff);
				arr["AdminPort"] = buff;
				stage++;
			}
				break;
			case 4:
			{
				TermSend("\nEnter an IP address from wich telnet connection will be allowed(ignored if console run type was choosed):\n");
				TermReadEx(buff);
				arr["AdminIP"] = buff;
				stage++;
			}
				break;
			case 5:
				TermSend("\nConfiguration succesfuly updated\nJust run IPUpdater and enjoy :)\nPress Enter to continue...\n");
				TermReadEx(NULL);
				stage++;
				break;
		}
	}
	cfg.SaveConfig(&arr, CONFIG_FILE);
	ExitApp = true;
}

void StartTerminalThread(void *param)
{
	if(hThread)
		StopTerminalThread();

	stopThread = false;

	SetReadCallback(&cbAdmin);
	// TODO: error handling
#ifdef WIN32
	hThread = CreateThread(
		NULL,
		16384,
		(LPTHREAD_START_ROUTINE)&TerminalThread,
		param,
		NULL,
		NULL
	);
#else
	pthread_create(&hThread, NULL, TerminalThread, param);
#endif
}

void StopTerminalThread()
{
	stopThread = true;

	if(hThread)
	{
		Sleep(1000);

#ifdef WIN32
		DWORD ExitCode = 0;
		GetExitCodeThread(hThread, &ExitCode);

		if(ExitCode == STILL_ACTIVE)
			TerminateThread(hThread, 1);

		CloseHandle(hThread);
#else
		//while(hThread)
			Sleep(200);
#endif
		hThread = 0;
	}
}

char *MD5Encode(char *string, OUT char *hash)
{
	u_char buff[16];
	MD5_CTX ctx;

	ZeroMemory(hash, 33); //33 - minimum buff len
	MD5Init(&ctx);
	MD5Update(&ctx, (u_char*)string, strlen(string));
	MD5Final(buff, &ctx);

    for(size_t i = 0; i < sizeof(buff); i++)
        sprintf(hash+strlen(hash), "%02x", buff[i]);

	return hash;
}

void cbAdmin(char *cmd)
{
	char buff[256];

	in_setup = true;
	if(!stricmp(cmd, "help"))
	{
		TermSend("\
Available commands:\r\n\r\n\
\tadd        - adds a subdomain\r\n\
\tchange     - change password for subdomain\r\n\
\tdelete     - remove a subdomain from config\r\n\
\tstatus     - show update status\r\n\
\tupdate     - update all domains\r\n\
\tadmin      - change IP address what can open telnet session\r\n\
\tport       - change telnet port\r\n\
\tupdateint  - change update interval\r\n\
\truntype    - change run type (telnet | console)\r\n\
\tsave       - save changes\r\n\
\tsetup      - create new configuration\r\n\
\tshutdown   - shutdown IPUpdater\r\n\
\texit       - close telnet session(telnet mode only)\r\n\
\thelp       - this help\r\n\r\n");
	}
	else if(!stricmp(cmd, "add"))
	{
		char domain[128];
		char pass[128];

		TermSend("Enter subdomain name in domain vfose.ru:\r\n");
		if(strlen(TermReadEx(domain)))
		{
			TermSend("Enter domain password:\r\n");
			if(strlen(TermReadEx(pass)))
			{
				int i = 0;
				char dBuff[12] = "Domain0"; //100000 total posible domains -)
				char passBuff[9] = "Hash";
				char *dId = dBuff + strlen(dBuff) - 1;
				char *passId = passBuff + strlen(passBuff);
				char hash[33];

				while(cfg.IsSet(dBuff))
				{
					sprintf(dId, "%i", ++i);
				}
				sprintf(passId, "%i", i);

				cfg.SetCfgVar(dBuff, domain);
				cfg.SetCfgVar(passBuff, MD5Encode(pass, hash));

				TermSend("Domain added succesfully:\r\n\r\n");
			}
			else
				TermSend("Can not set empty password\r\n\r\n");
		}
		else
			TermSend("Can not add empty subdomain\r\n\r\n");
	}
	else if(!stricmp(cmd, "change"))
	{
		int i = 0;
		char dBuff[12] = "Domain0"; //100000 total posible domains -)
		char *dId = dBuff + strlen(dBuff) - 1;

		TermSend("Choose a subdomain number:\r\n");
		while(cfg.IsSet(dBuff))
		{
			sprintf(buff, "\t%i) %s\r\n", i, cfg.GetCfgVar(dBuff));
			TermSend(buff);

			sprintf(dId, "%i", ++i);
		}

		if(strlen(TermReadEx(buff)))
		{
			sprintf(dId, buff);
			if(cfg.IsSet(dBuff))
			{
				TermSend("Enter new password:\r\n");
				if(strlen(TermReadEx(buff)))
				{
					cfg.SetCfgVar(dBuff, buff);
					TermSend("Password changed succesfully:\r\n\r\n");
				}
				else
					TermSend("Can not set empty password\r\n\r\n");
			}
			else
				TermSend("Wrong choice\r\n\r\n");
		}
		else
			TermSend("Wrong choice\r\n\r\n");
	}
	else if(!stricmp(cmd, "delete"))
	{
		int i = 0;
		char dBuff[12] = "Domain0"; //100000 total posible domains -)
		char *dId = dBuff + strlen(dBuff) - 1;

		TermSend("Choose a subdomain number:\r\n");
		while(cfg.IsSet(dBuff))
		{
			sprintf(buff, "\t%i) %s\r\n", i, cfg.GetCfgVar(dBuff));
			TermSend(buff);

			sprintf(dId, "%i", ++i);
		}

		if(strlen(TermReadEx(buff)))
		{
			sprintf(dId, buff);
			i = atoi(buff);

			if(cfg.IsSet(dBuff))
			{
				sprintf(buff, "Delete %s.vfose.ru from config? [yn]", cfg.GetCfgVar(dBuff));
				TermSend(buff);
				if(strlen(TermReadEx(buff)))
				{
					if(!stricmp(buff, "y"))
					{
						char passBuff[9] = "Hash";
						char *passId = passBuff + strlen(passBuff);
						sprintf(passId, "%i", i);

						cfg.DeleteVar(dBuff);
						cfg.DeleteVar(passBuff);

						do
						{
							sprintf(dId, "%i", ++i);
							sprintf(passId, "%i", i);

							if(cfg.IsSet(dBuff))
							{
								strcpy(buff, dBuff);
								sprintf(dId, "%i", i-1);
								cfg.SetCfgVar(dBuff, cfg.GetCfgVar(buff));
								cfg.DeleteVar(buff);
								strcpy(buff, passBuff);
								sprintf(passId, "%i", i-1);
								cfg.SetCfgVar(passBuff, cfg.GetCfgVar(buff));
								cfg.DeleteVar(buff);
							}
						}
						while(cfg.GetCfgVar(dBuff));

						TermSend("Domain succesfully removed\r\n\r\n");
					}
				}
				else
					TermSend("Domain not removed\r\n\r\n");
			}
			else
				TermSend("Wrong choice\r\n\r\n");
		}
		else
			TermSend("Wrong choice\r\n\r\n");
	}
	else if(!stricmp(cmd, "status"))
	{
		TermSend(ipu.GetStatus());
	}
	else if(!stricmp(cmd, "update"))
	{
		ipu.UpdateAllDomains();
		TermSend("OK\r\n\r\n");
	}
	else if(!stricmp(cmd, "admin"))
	{
		TermSend("Enter Admin IP address:\r\n");
		if(strlen(TermReadEx(buff)))
		{
			cfg.SetCfgVar("AdminIP", buff);
			TermSend("OK\r\n\r\n");
		}
		else
			TermSend("Can not set empty IP\r\n\r\n");
	}
	else if(!stricmp(cmd, "port"))
	{
		TermSend("Enter port for telnet connections:\r\n");
		if(strlen(TermReadEx(buff)))
		{
			cfg.SetCfgVar("AdminPort", buff);
			TermSend("OK\r\n\r\n");
		}
		else
			TermSend("Can not set empty port\r\n\r\n");
	}
	else if(!stricmp(cmd, "updateint"))
	{
		TermSend("Enter interval between updates in secs:\r\n");
		if(strlen(TermReadEx(buff)))
		{
			cfg.SetCfgVar("UpdateInterval", buff);
			TermSend("OK\r\n\r\n");
		}
		else
			TermSend("Can not set empty interval\r\n\r\n");
	}
	else if(!stricmp(cmd, "runtype"))
	{
		TermSend("Enter run type: [telnet|console]\r\n");
		if(strlen(TermReadEx(buff)))
		{
			cfg.SetCfgVar("RunType", buff);
			TermSend("OK\r\n\r\n");
		}
		else
			TermSend("Wrong choice\r\n\r\n");
	}
	else if(!stricmp(cmd, "save"))
	{
		cfg.SaveConfig(NULL, CONFIG_FILE);
		TermSend("OK\r\n\r\n");
	}
	else if(!stricmp(cmd, "setup"))
	{
		TermSend("It will erase current config. Continue?\r\n");
		if(strlen(TermReadEx(buff)))
		{
			if(!stricmp(buff, "y"))
				SetUp();
		}
		else
			TermSend("Wrong choice\r\n\r\n");
	}
	else if(!stricmp(cmd, "shutdown"))
	{
		TermSend("Are you sure?\r\n");
		if(strlen(TermReadEx(buff)))
		{
			if(!stricmp(buff, "y"))
			{
				TermSend("Bye bye!");
				ExitApp = true;
			}
		}
		else
			TermSend("Wrong choice\r\n\r\n");
	}
	else if(!stricmp(cmd, "exit"))
	{
		TermSend("Bye bye!");
		StopTerminal(); // TODO
		StartTerminal();
	}
	else
		TermSend("Type `help` to see available commands\r\n\r\n");

	in_setup = false;
}

